diff --git a/toolkit/crashreporter/google-breakpad/src/processor/stackwalker_x86.cc b/toolkit/crashreporter/google-breakpad/src/processor/stackwalker_x86.cc
--- a/toolkit/crashreporter/google-breakpad/src/processor/stackwalker_x86.cc
+++ b/toolkit/crashreporter/google-breakpad/src/processor/stackwalker_x86.cc
@@ -74,30 +74,31 @@ StackFrame* StackwalkerX86::GetContextFr
   }
 
   StackFrameX86 *frame = new StackFrameX86();
 
   // The instruction pointer is stored directly in a register, so pull it
   // straight out of the CPU context structure.
   frame->context = *context_;
   frame->context_validity = StackFrameX86::CONTEXT_VALID_ALL;
+  frame->trust = StackFrameX86::FRAME_TRUST_CONTEXT;
   frame->instruction = frame->context.eip;
 
   return frame;
 }
 
 
 StackFrame* StackwalkerX86::GetCallerFrame(
     const CallStack *stack,
     const vector< linked_ptr<StackFrameInfo> > &stack_frame_info) {
   if (!memory_ || !stack) {
     BPLOG(ERROR) << "Can't get caller frame without memory or stack";
     return NULL;
   }
-
+  StackFrameX86::FrameTrust trust = StackFrameX86::FRAME_TRUST_NONE;
   StackFrameX86 *last_frame = static_cast<StackFrameX86*>(
       stack->frames()->back());
   StackFrameInfo *last_frame_info = stack_frame_info.back().get();
 
   // This stackwalker sets each frame's %esp to its value immediately prior
   // to the CALL into the callee.  This means that %esp points to the last
   // callee argument pushed onto the stack, which may not be where %esp points
   // after the callee returns.  Specifically, the value is correct for the
@@ -178,16 +179,17 @@ StackFrame* StackwalkerX86::GetCallerFra
   // without any need for scanning.  The results of program string evaluation
   // will be used to determine whether to scan for better values.
   string program_string;
   bool traditional_frame = true;
   bool recover_ebp = true;
   if (last_frame_info && last_frame_info->valid == StackFrameInfo::VALID_ALL) {
     // FPO data available.
     traditional_frame = false;
+    trust = StackFrameX86::FRAME_TRUST_CFI;
     if (!last_frame_info->program_string.empty()) {
       // The FPO data has its own program string, which will tell us how to
       // get to the caller frame, and may even fill in the values of
       // nonvolatile registers and provide pointers to local variables and
       // parameters.  In some cases, particularly with program strings that use
       // .raSearchStart, the stack may need to be scanned afterward.
       program_string = last_frame_info->program_string;
     } else if (last_frame_info->allocates_base_pointer) {
@@ -275,30 +277,50 @@ StackFrame* StackwalkerX86::GetCallerFra
     //
     // Instruction and frame pointer recovery for these traditional frames is
     // entirely deterministic, and the stack will not be scanned after
     // recovering these values.
     //
     // %eip_new = *(%ebp_old + 4)
     // %esp_new = %ebp_old + 8
     // %ebp_new = *(%ebp_old)
+    trust = StackFrameX86::FRAME_TRUST_FP;
     program_string = "$eip $ebp 4 + ^ = "
                      "$esp $ebp 8 + = "
                      "$ebp $ebp ^ =";
   }
 
   // Now crank it out, making sure that the program string set at least the
   // two required variables.
   PostfixEvaluator<u_int32_t> evaluator =
       PostfixEvaluator<u_int32_t>(&dictionary, memory_);
   PostfixEvaluator<u_int32_t>::DictionaryValidityType dictionary_validity;
   if (!evaluator.Evaluate(program_string, &dictionary_validity) ||
       dictionary_validity.find("$eip") == dictionary_validity.end() ||
       dictionary_validity.find("$esp") == dictionary_validity.end()) {
-    return NULL;
+    // Program string evaluation failed. It may be that %eip is not somewhere
+    // with stack frame info, and %ebp is pointing to non-stack memory, so
+    // our evaluation couldn't succeed. We'll scan the stack for a return
+    // address. This can happen if the stack is in a module for which
+    // we don't have symbols, and that module is compiled without a
+    // frame pointer.
+    u_int32_t location_start = last_frame->context.esp;
+    u_int32_t location, eip;
+    if (!ScanForReturnAddress(location_start, location, eip)) {
+      // if we can't find an instruction pointer even with stack scanning,
+      // give up.
+      return NULL;
+    }
+
+    // This seems like a reasonable return address. Since program string
+    // evaluation failed, use it and set %esp to the location above the
+    // one where the return address was found.
+    dictionary["$eip"] = eip;
+    dictionary["$esp"] = location + 4;
+    trust = StackFrameX86::FRAME_TRUST_SCAN;
   }
 
   // If this stack frame did not use %ebp in a traditional way, locating the
   // return address isn't entirely deterministic.  In that case, the stack
   // can be scanned to locate the return address.
   //
   // Even in nontraditional frames, if program string evaluation resulted in
   // both %eip and %ebp values of 0, trust that the end of the stack has been
@@ -316,43 +338,28 @@ StackFrame* StackwalkerX86::GetCallerFra
     // require dumps that contain MINIDUMP_MEMORY_INFO, which the Breakpad
     // client doesn't currently write (it would need to call MiniDumpWriteDump
     // with the MiniDumpWithFullMemoryInfo type bit set).  Even given this
     // ability, older OSes (pre-XP SP2) and CPUs (pre-P4) don't enforce
     // an independent execute privilege on memory pages.
 
     u_int32_t eip = dictionary["$eip"];
     if (modules_ && !modules_->GetModuleForAddress(eip)) {
-      const int kRASearchWords = 15;
-
       // The instruction pointer at .raSearchStart was invalid, so start
       // looking one 32-bit word above that location.
       u_int32_t location_start = dictionary[".raSearchStart"] + 4;
-
-      for (u_int32_t location = location_start;
-           location <= location_start + kRASearchWords * 4;
-           location += 4) {
-        if (!memory_->GetMemoryAtAddress(location, &eip))
-          break;
-
-        if (modules_->GetModuleForAddress(eip)) {
-          // This is a better return address that what program string
-          // evaluation found.  Use it, and set %esp to the location above the
-          // one where the return address was found.
-          //
-          // TODO(mmentovai): The return-address check can be made even
-          // stronger in modules for which debugging data is available.  In
-          // that case, it's possible to check that the candidate return
-          // address is inside a known function.
-
-          dictionary["$eip"] = eip;
-          dictionary["$esp"] = location + 4;
-          offset = location - location_start;
-          break;
-        }
+      u_int32_t location;
+      if (ScanForReturnAddress(location_start, location, eip)) {
+        // This is a better return address that what program string
+        // evaluation found.  Use it, and set %esp to the location above the
+        // one where the return address was found.
+        dictionary["$eip"] = eip;
+        dictionary["$esp"] = location + 4;
+        offset = location - location_start;
+        trust = StackFrameX86::FRAME_TRUST_CFI_SCAN;
       }
     }
 
     // When trying to recover the previous value of the frame pointer (%ebp),
     // start looking at the lowest possible address in the saved-register
     // area, and look at the entire saved register area, increased by the
     // size of |offset| to account for additional data that may be on the
     // stack.  The scan is performed from the highest possible address to
@@ -387,16 +394,17 @@ StackFrame* StackwalkerX86::GetCallerFra
       dictionary["$esp"] <= last_frame->context.esp) {
     return NULL;
   }
 
   // Create a new stack frame (ownership will be transferred to the caller)
   // and fill it in.
   StackFrameX86 *frame = new StackFrameX86();
 
+  frame->trust = trust;
   frame->context = last_frame->context;
   frame->context.eip = dictionary["$eip"];
   frame->context.esp = dictionary["$esp"];
   frame->context.ebp = dictionary["$ebp"];
   frame->context_validity = StackFrameX86::CONTEXT_VALID_EIP |
                                 StackFrameX86::CONTEXT_VALID_ESP |
                                 StackFrameX86::CONTEXT_VALID_EBP;
 
@@ -423,10 +431,32 @@ StackFrame* StackwalkerX86::GetCallerFra
   // with the line that contains a function call.  Callers that require the
   // exact return address value may access the context.eip field of
   // StackFrameX86.
   frame->instruction = frame->context.eip - 1;
 
   return frame;
 }
 
+bool StackwalkerX86::ScanForReturnAddress(u_int32_t location_start,
+                                          u_int32_t &location_found,
+                                          u_int32_t &eip_found) {
+  const int kRASearchWords = 15;
+  for (u_int32_t location = location_start;
+       location <= location_start + kRASearchWords * 4;
+       location += 4) {
+    u_int32_t eip;
+    if (!memory_->GetMemoryAtAddress(location, &eip))
+      break;
+
+    if (modules_ && modules_->GetModuleForAddress(eip) &&
+        InstructionAddressSeemsValid(eip)) {
+
+      eip_found = eip;
+      location_found = location;
+      return true;
+    }
+  }
+  // nothing found
+  return false;
+}
 
 }  // namespace google_breakpad
diff --git a/toolkit/crashreporter/google-breakpad/src/processor/stackwalker_x86.h b/toolkit/crashreporter/google-breakpad/src/processor/stackwalker_x86.h
--- a/toolkit/crashreporter/google-breakpad/src/processor/stackwalker_x86.h
+++ b/toolkit/crashreporter/google-breakpad/src/processor/stackwalker_x86.h
@@ -65,16 +65,29 @@ class StackwalkerX86 : public Stackwalke
   // Implementation of Stackwalker, using x86 context (%ebp, %esp, %eip) and
   // stack conventions (saved %ebp at [%ebp], saved %eip at 4[%ebp], or
   // alternate conventions as guided by stack_frame_info_).
   virtual StackFrame* GetContextFrame();
   virtual StackFrame* GetCallerFrame(
       const CallStack *stack,
       const vector< linked_ptr<StackFrameInfo> > &stack_frame_info);
 
+  // Scan the stack starting at location_start, looking for an address
+  // that looks like a valid instruction pointer. Addresses must
+  // 1) be contained in the current stack memory
+  // 2) pass the checks in Stackwalker::InstructionAddressSeemsValid
+  //
+  // Returns true if a valid-looking instruction pointer was found.
+  // When returning true, sets location_found to the address at which
+  // the value was found, and eip_found to the value contained at that
+  // location in memory.
+  bool ScanForReturnAddress(u_int32_t location_start,
+                            u_int32_t &location_found,
+                            u_int32_t &eip_found);
+
   // Stores the CPU context corresponding to the innermost stack frame to
   // be returned by GetContextFrame.
   const MDRawContextX86 *context_;
 };
 
 
 }  // namespace google_breakpad
 
diff --git a/toolkit/crashreporter/google-breakpad/src/processor/testdata/linux_test_app.cc b/toolkit/crashreporter/google-breakpad/src/processor/testdata/linux_test_app.cc
new file mode 100644
--- /dev/null
+++ b/toolkit/crashreporter/google-breakpad/src/processor/testdata/linux_test_app.cc
@@ -0,0 +1,81 @@
+// Copyright (c) 2009, Google Inc.
+// All rights reserved.
+//
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are
+// met:
+//
+//     * Redistributions of source code must retain the above copyright
+// notice, this list of conditions and the following disclaimer.
+//     * Redistributions in binary form must reproduce the above
+// copyright notice, this list of conditions and the following disclaimer
+// in the documentation and/or other materials provided with the
+// distribution.
+//     * Neither the name of Google Inc. nor the names of its
+// contributors may be used to endorse or promote products derived from
+// this software without specific prior written permission.
+//
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// Breakpad test application for Linux. When run, it generates one on-demand
+// minidump and then crashes, which should generate an on-crash minidump.
+// dump_syms can be used to extract symbol information for use in processing.
+
+// To build:
+// g++ -g -o linux_test_app -I ../../ -L../../client/linux linux_test_app.cc \
+//   -lbreakpad
+// Add -m32 to build a 32-bit executable, or -m64 for a 64-bit one
+// (assuming your environment supports it). Replace -g with -gstabs+ to
+// generate an executable with STABS symbols (needs -m32), or -gdwarf-2 for one
+// with DWARF symbols (32- or 64-bit)
+
+#include <sys/types.h>
+#include <unistd.h>
+#include <cstdio>
+#include <string>
+
+#include "common/linux/linux_syscall_support.h"
+#include "client/linux/handler/exception_handler.h"
+
+namespace {
+
+// google_breakpad::MinidumpCallback to invoke after minidump generation.
+static bool callback(const char *dump_path, const char *id,
+                     void *context,
+                     bool succeeded) {
+  if (succeeded) {
+    printf("dump guid is %s\n", id);
+  } else {
+    printf("dump failed\n");
+  }
+  fflush(stdout);
+
+  return succeeded;
+}
+
+static void CrashFunction() {
+  int *i = reinterpret_cast<int*>(0x45);
+  *i = 5;  // crash!
+}
+
+}  // namespace
+
+int main(int argc, char **argv) {
+  google_breakpad::ExceptionHandler eh(".", NULL, callback, NULL, true);
+  if (!eh.WriteMinidump()) {
+    printf("Failed to generate on-demand minidump\n");
+  }
+  CrashFunction();
+  printf("did not crash?\n");
+  return 0;
+}
